#include <QtCore/QCoreApplication>
#include <QtCore/qglobal.h>

#include <QtWidgets>

class TableModel1: public QAbstractTableModel {
public:
    virtual int rowCount(const QModelIndex &parent) const override {
        return 1;
    }
    virtual int columnCount(const QModelIndex &parent) const override {
        return 2;
    }
    virtual QVariant data(const QModelIndex &index, int role) const override {
        if (role == Qt::DisplayRole) {
            return QLatin1String("Model 1");
        }
        return QVariant();
    }
};

class TableModel2: public QAbstractTableModel {
public:
    virtual int rowCount(const QModelIndex &parent) const override {
        return 1;
    }
    virtual int columnCount(const QModelIndex &parent) const override {
        return 3;
    }
    virtual QVariant data(const QModelIndex &index, int role) const override {
        if (role == Qt::DisplayRole) {
            return QLatin1String("Model 2");
        }
        return QVariant();
    }
};

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QWidget mainWindow;
    mainWindow.setLayout(new QVBoxLayout());

    QTableView* tableView1 = new QTableView(&mainWindow);
    TableModel1* model1 = new TableModel1();
    tableView1->setModel(model1);

    QTableView* tableView2 = new QTableView(&mainWindow);
    TableModel2* model2 = new TableModel2();
    tableView2->setModel(model2);

    QPushButton* btn = new QPushButton(&mainWindow);
    btn->setText(QLatin1String("Corrupt header"));
    QObject::connect(btn, &QAbstractButton::clicked,
                     [=](){
        tableView2->horizontalHeader()->restoreState(
                    tableView1->horizontalHeader()->saveState());
    });


    mainWindow.layout()->addWidget(tableView1);
    mainWindow.layout()->addWidget(tableView2);
    mainWindow.layout()->addWidget(btn);

    mainWindow.show();

    return a.exec();
}
